# mkgray.pl -- gateway to weather
#
# $Id: weather.pl,v 1.3 93/10/14 02:21:45 bert Exp $
#
# Matthew Gray (mkgray@athena.mit.edu)
#

require 'chat2.pl';

package weather;

sub main'do_weather {
    local($station, $cmd) = @_;
    if ($cmd eq "usmap") {
	&do_usmap($station);
    }
    elsif ($station) {
	$station =~ s/\+/ /g;
	print "<isindex>".&get_weather($station)."</pre>";
    }
    else{
	print <<"EndOfInfo";
<TITLE>Weather</TITLE>
<h1>Weather</H1>
This is the new, barely tested weather gateway.  If you find any bugs,
send mail to <em>webmaster@athena</em> or enter
<a href="http://www.mit.edu:8001/comment">short comments here</a>.<p>
If you know the city code of the forecast you want, enter it in the
search field.<p>
<H2><A HREF="usa.html">Click here for current weather map and forecasts
across the nation</A></H2><P>
<H2><A HREF="weather?bos">Click here for Boston forecast</A></H2><P>
<ISINDEX>
EndOfInfo
    }
}

sub do_usmap {
    local($args) = @_;
    local($x, $y) = split(',', $args);

    @name = ('BOS','LAX','MCO','TOP','NYC','SLC','BWI','FTW','CHI','NEW',
	     'DSM','DEN','MEM','PHX','SEA');
    @x = (750,100,675,440,700,225,700,400,550,500,475,300,600,200,150);
    @y = (175,325,475,320,200,250,250,450,250,475,260,300,350,375,100);

    $min = 1000000;
    foreach $n (0..$#x){
	$locale = $name[$n];
	if(($dist=&distance($x, $y, $x[$n], $y[$n])) < $min){
	    $min = $dist;
	    $whereami = $locale;
	}
    }

    print("<title>Nearest Weather Station is $whereami</title><isindex>\n");
    print &get_weather($whereami)."</pre>";
}

sub distance {
    local($x1, $y1, $x2, $y2) = @_;
    local($xd) = (($x1-$x2)*($x1-$x2));
    local($sqd)=$xd + (($y1-$y2)*($y1-$y2));
    $sqd;
}

sub get_weather {
    local($station) = @_;
    
    $closeme = &chat'open_port('downwind.sprl.umich.edu', 3000);
    &listen(2);
    &chat'print($station."\n");
    while($forecast!~/CITY FORECAST MENU/){
	$forecast .= &listen(1);
	&chat'print("\n");
    }
    &chat'print("x\n");
    &chat'close($closeme);
    $forecast=~s/Press Return to continue, M to return to menu, X to exit://g;
    $forecast=~s/CITY FORECAST MENU[\w\W]+//;
    $forecast=~s/\n\W\W([^\.\n]+)\.\.\./\n<h2>\1:<\/h2>/g;
    $forecast=~s/(Weather Conditions at .+)/<h1>\1<\/h1><pre>/;
    $forecast=~s/\n(.+)FORECAST\n/\n<h2>\1FORECAST<\/h2>\n/;
    return $forecast;
}
sub listen {
        local($secs) = @_;
        local($return,$tmp) = "";
        while (length($tmp = &chat'expect($secs, '(.|\n)+', '$&'))) {
                print $tmp if $trace;
                $return .= $tmp;
        }
        $return;
}

1;
