#
# log-nomail.pl -- non-mailing logger! =)
#
# derived from log-simple.pl (original author: Tony Sanders <sanders@bsdi.com>)

package logger;

sub init {
    local($err) = "/var/local/www/errors";    # this is a crock
    local($log) = $main'plexus_log || shift;
    local($umask) = umask(002);
    &main'debug("openerr $err");
    open(ERR, ">>$err") || die "$err: $!";
    select((select(ERR), $| = 1)[0]);
    &main'debug("errfd ", fileno(ERR));
    &main'debug("openlog $log");
    open(LOG, ">>$log") || die "$log: $!";
    select((select(LOG), $| = 1)[0]);
    &main'debug("logfd ", fileno(LOG));
    umask($umask);
}

sub message {
    local($msg) = @_;
    &main'set_timeout();
    &main'seize(LOG, &main'LOCK_EX);
    print LOG $msg;
    &main'seize(LOG, &main'LOCK_UN);
    &main'clear_timeout;
}

sub error {
    local($status, $msg) = @_;
    &main'set_timeout();
    &main'seize(ERR, &main'LOCK_EX);
    print ERR "---- ",&main'ctime(time);
    print ERR "$status\n";
    print ERR "$msg\n";
    &main'seize(ERR, &main'LOCK_UN);
    &main'clear_timeout;
}

sub close { close(ERR); close(LOG); }

1;
